<?php
//掲示板でしか使わない関数。読むのは最後

//セッション復活!
session_start();

//トリップ
function t_key(string $name, string $key){
	if ($key === ''){
		return '';
	} else {
		$name = mb_convert_encoding($name, 'sjis');
		$key = mb_convert_encoding($key, 'sjis');
		$len = strlen($name.$key);
		$sa = base64_encode(hash('sha256', $name.$key));
		$sa = substr(preg_replace('/[^\.-z]/', '.', $sa), -5);
		$sa = strtr($sa, ':;<=>?@[\\]^_`', 'ABCDEFGabcdef');
		$tkey = crypt($key.$name, $sa);
		$tkey = substr($tkey, max(-12, -$len));
		return $tkey;
	}
}

//投稿表示
function user_page(string $name, string $key){
	if (empty($key)){
		return str_replace('◆', '◇', $name);
	} else {
		return '<a href="/user_page.php?User='.encode_a($name).'&Key='.encode_a($key).'">'.str_replace('◆', '◇', $name).'◆'.$key.'</a>';
	}
}
function view_comment(array $d, string $title, string $edit_form){
	$text = $d[5];
	if (strpos($text, '\\\\非表示\\\\') !== false){
		$text = '<i style="border:dashed #00a 1px;display:block;text-align:center;color:#f55;">非表示(投稿者または管理人によるものです)</i>';
		$d[1] = '非表示';
		$d[2] = '';
	} else {
		$text = preg_replace('/(&gt;&gt;)([0-9]+)/', '<a href="#$2">&gt;&gt;$2</a>', $text);
		$text = preg_replace('/((https|http):\/\/[-_.!~*\'()a-zA-Z0-9;\/?:@&=+$,%#]+)/ ', '<a href="$1" target="_blank">$1</a>', $text);
		$d1 = strpos($text, '{{');
		if ($d1 !== false){
			$d2 = strpos($text, '}}');
			if (($d2 !== false) && ($d2 > $d1)){
				$d1_a = $d1 + 2;
				$d2_a = $d2 - $d1 - 2;
				$text_a = substr($text, $d1_a, $d2_a);
				if (preg_match('/[0-9]+\.(gif|png|jpeg|jpg|webp|ico)/', $text_a) === 1){
					global $d_root;
					global $img_count;
					$img_name = $d_root.'/sqlike/bbs/file/'.$text_a;
					if (file_exists($img_name)){
						$i = getimagesize($img_name);
						$icode = '{{'.$text_a.'}}';
						$img_url = 'img.php?P='.encode_a(s_pass_e($text_a));
						++$img_count;
						if ($img_count >= 20){
$text = str_replace($icode,'<a href="/'.$img_url.'" target="_blank">画像を表示するにはここをクリックして下さい</a>',$text);
						} else {
$text = str_replace($icode,'<a href="/'.$img_url.'" target="_blank"><img src="/'.$img_url.'&imageonly=true" width="'.$i[0].'px" height="'.$i[1].'px" alt="'.h(mb_substr(str_replace($icode,'',preg_replace('/&gt;&gt;[0-9]+/', '', $text)),0,8)).'"></a>',$text);
						}
					}
				}
			}
		}
	}
echo '<div class="msg"><p id="'.$d[0].'">'.$d[0].'. <span class="usr">'.$title.user_page($d[1],$d[2]).'</span> '.$d[3].'</p><p class="'.$d[4].'">'.$text.$edit_form.'</p></div>';
}

//投稿回数警告
function post_warning(string $s_name, string $s_key){
	global $d_root;
	if (!empty($s_name)){
		$user_revel_file = $d_root.'/sqlike/user/revel/'.encode_a(h($s_name)).'('.encode_a(t_key(h($s_name), h($s_key))).').txt';
		if (file_exists($user_revel_file)){
			$post_count = get($user_revel_file, 1);
			if (!empty($post_count)){
				$warn = (($post_count * $post_count) + $post_count) / 2;
				$warn = round(log10($warn));
echo '<p style="border:dotted .1em #0a0;background:#fff;">貴方は'.$post_count.'回投稿しました。 生徒指導度'.$warn.'　<a href="/menu.php?Page=4" title="投稿数カウントについて">もっと</a></p>';
			}
		}
	}
}

//色一覧
function color_options(array $color_list, array $color_name_list, string $s_color){
echo '<div><p>文字色<br>';
	$count = 0;
	foreach ($color_list as $c){
echo '<label class="'.$c.'"><input type="radio" name="color" value="'.$c.'" id="'.$c.'"';
if ($s_color === $c){
	echo ' checked';
}
echo '>'.$color_name_list[$count].'</label> ';
		++$count;
	}
echo '</p></div>';
}

function bbs_post_count(string $name, string $key){
	global $d_root;
	unlink_by_date($d_root.'/sqlike/user/revel', 3600 * 24 * 300);
	$key = t_key($name, $key);
	$post_count = 0;
	$fols = scandir($d_root.'/sqlike/bbs');
	foreach ($fols as $b){
		if (preg_match('/^[0-9]+$/', $b) === 1){
			$thread_files = scandir($d_root.'/sqlike/bbs/'.$b);
			foreach ($thread_files as $thread_file){
				if (preg_match('/^[0-9]+\.txt$/', $thread_file) === 1){
					$thread_rows = get_rows($d_root.'/sqlike/bbs/'.$b.'/'.$thread_file, 2);
					foreach ($thread_rows as $thread_row){
						$d = explode("'", $thread_row);
						if (($d[1] === $name) && ($d[2] === $key)){
							++$post_count;
						}
					}
				}
			}
		}
	}
	$user_revel_file = $d_root.'/sqlike/user/revel/'.encode_a($name).'('.encode_a($key).').txt';
	file_put_contents($user_revel_file, (string)$post_count, LOCK_EX);
}

$color_list = ['color_b','color_r','color_v','color_o','color_gr','color_dg','color_bl','color_lz','color_ja','color_p','color_pp','color_wd','color_pn','color_db'];
$color_name_list = ['黒色','赤色','紫色','橙色','緑色','深緑','青色','瑠璃','翠色','水色','小豆','茶色','紅色','藍色'];
$img_count = 0;

function rand_comment(){
	$l = ['(=ω=.)','(≡ω≡.)','＼(=ω=.)／','＼(≡ω≡.)／','\(^o^)/','┗(^o^ )┓','( ^ω^ )','(￣ー￣)','(￣▽￣)','(*•̀ᴗ•́*)','( • ̀ω•́ )','( ˘ω˘ ; )','(((;´•ω•`;)))','( >_< )','(﹡ˆᴗˆ﹡)'];
	return $l[mt_rand(0, 14)];
}

