<?php
//取り込む順番:私が最初。submit.phpが次、form.phpが最後。

header('Content-Type:text/html;charset=UTF-8');
header('Referrer-Policy:same-origin');

//基本文字列操作
function h(string $t){return htmlspecialchars($t, ENT_QUOTES, 'UTF-8');}
function L1(string $str){return preg_replace('/\r\n|\r|\n/', '', $str);}
function p(string $str){return preg_replace('/\r\n|\r|\n/', '', nl2br(h($str), false));}
function encode_a(string $s){return str_replace('+', '-', str_replace('/', '_', base64_encode($s)));}
function decode_a(string $s){return base64_decode(str_replace('_', '/', str_replace('-', '+', $s)));}
function one_time_pass(int $min, int $max){return encode_a(random_bytes(random_int($min, $max)));}

//ファイル
function get(string $file, int $l){
	if (!file_exists($file)){
		return false;
	}
	$fp = fopen($file, 'r');
	for ($i=0;$i < $l;++$i){
		$out = fgets($fp);
	}
	fclose($fp);
	if (isset($out)){
		return trim($out);
	} else {
		return false;
	}
}
function get_rows(string $file, int $start){
	$lines = file($file, FILE_IGNORE_NEW_LINES);
	if ($lines === false){
		return false;
	}
	$start = $start -1;
	return array_slice($lines, $start);
}

function unlink_by_date(string $path, int $time_limit){
	$file = scandir($path);
	if ($file === false){
		return false;
	} else {
		$now = time();
		foreach ($file as $f){
			if ($f === '.' || $f === '..'){
				continue;
			}
			$f_p = $path.'/'.$f;
			$f_t = filemtime($f_p);
			if ($f_t !== false && ($now - $f_t) >= $time_limit){
				unlink($f_p);
			}
		}
	}
}
function file_lock(string $f){
	global $d_root;
	$f = $d_root.'/sqlike/swap/.'.$f;
	while (file_exists($f)){
		usleep(100);
	}
	file_put_contents($f, '', LOCK_EX);
}
function file_unlock(string $f){
	global $d_root;
	$f = $d_root.'/sqlike/swap/.'.$f;
	if (file_exists($f)){
		unlink($f);
	}
}

//暗号系256固定
function pass(string $passwd){
	if(empty($passwd)){
		return '';
	}else{
		return hash('sha256', $passwd);
	}
}
function s_pass_d(string $passwd){
	if(empty($passwd)){
		return '';
	} else {
		global $d_root;
		return openssl_decrypt($passwd, 'aes-256-ecb', file_get_contents($d_root.'/sqlike/own/key.txt'));
	}
}
function s_pass_e(string $passwd){
	if (empty($passwd)){
		return '';
	} else {
		global $d_root;
		return openssl_encrypt($passwd, 'aes-256-ecb', file_get_contents($d_root.'/sqlike/own/key.txt'));
	}
}


//変数
$here = (empty($_SERVER['HTTPS'])?'http://':'https://').(isset($_SERVER['HTTP_HOST'])?$_SERVER['HTTP_HOST']:'unset').(isset($_SERVER['REQUEST_URI'])?$_SERVER['REQUEST_URI']:'unset');
$domain = (empty($_SERVER['HTTPS'])?'http://':'https://').(isset($_SERVER['HTTP_HOST'])?$_SERVER['HTTP_HOST']:'unset').'/';

//規定
$nonce = one_time_pass(20, 30);
header("Content-Security-Policy:connect-src 'self';object-src 'none';base-uri 'self';script-src 'nonce-{$nonce}' 'unsafe-inline';");




//html出力
function html_head(string $title, string $description, string $ext_css_file, bool $robots){
	function read_css_file(string $css_file){
		$fp = fopen($css_file, 'r');
		while (($i = fgets($fp)) !== false){
			if (substr($i, 0, 2) !== '/*'){
				echo trim($i);
			}
		}
	}
	global $d_root;
	$html_file = $d_root.'/sqlike/html/head.html';
	if (!file_exists($html_file)){
		exit;
	}
	$html = file_get_contents($html_file);
	if ($description === ''){
		$description = 'とくになし。';
	}
	foreach (['{DESCRIPTION}' => $description, '{TITLE}' => $title] as $s => $t){
		$html = str_replace($s, $t, $html);
	}
	if ($robots === false){
		$html = str_replace('<ti', '<meta name="robots" content="noindex">'.PHP_EOL.'<ti', $html);
	}
	$html = explode('{CSS}', $html);
	echo $html[0];
	$css_file = $d_root.'/sqlike/css/a.css';
	if (file_exists($css_file)){
		read_css_file($css_file);
	}
	if (($ext_css_file !== '') && file_exists($ext_css_file)){
		read_css_file($ext_css_file);
	}
	echo $html[1];
}
function html_foot(string $js_file, string $extnd){
	global $d_root;
	global $nonce;
	$f = $d_root.'/sqlike/html/foot.html';
	if (!file_exists($f)){
		exit;
	}
	if (($js_file !== '') && file_exists($js_file)){
		$html = explode('</bo', file_get_contents($f));
		echo $html[0].'<script nonce="'.$nonce.'">';
		include $js_file;
		echo '</script></bo'.$html[1];
	} else {
		include $f;
	}
}

function not_found(){
	global $d_root;
	$f = $d_root.'/404.php';
	if (file_exists($f)){
		include $f;
	}
	exit;
}

